package github.benjamin.equipreservebackend.controller;

import github.benjamin.equipreservebackend.vo.LoginResponse;
import github.benjamin.equipreservebackend.response.ResponseResult;
import github.benjamin.equipreservebackend.entity.User;
import github.benjamin.equipreservebackend.security.SecurityUser;
import github.benjamin.equipreservebackend.service.UserService;
import github.benjamin.equipreservebackend.utils.JwtUtil;
import lombok.RequiredArgsConstructor;
import org.springframework.web.bind.annotation.PostMapping;
import org.springframework.web.bind.annotation.RestController;

@RestController
@RequiredArgsConstructor
public class UserController {

    private final UserService userService;

    private final JwtUtil jwtUtil;

    @PostMapping("/login")
    public ResponseResult<LoginResponse> login(String username, String password) {
        User user = userService.login(username, password);
        SecurityUser securityUser = userService.loadSecurityUserById(user.getId());
        String token = jwtUtil.generateToken(securityUser);
        return ResponseResult.success(new LoginResponse(user.getId(), user.getName(), token));
    }
}
